<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from parguide.texi on 28 April 1999 -->

<TITLE>The SUIF Parallelizing Compiler Guide - Introduction</TITLE>
<link href="parguide_2.html" rel=Next>
<link href="parguide_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the first, previous, <A HREF="parguide_2.html">next</A>, <A HREF="parguide_6.html">last</A> section, <A HREF="parguide_toc.html">table of contents</A>.
<P><HR><P>


<H1><A NAME="SEC1" HREF="parguide_toc.html#TOC1">Introduction</A></H1>

<P>
The SUIF parallelizing compiler translates sequential programs into
parallel code for shared address space machines.  The compiler generates
a single-program, multiple-data (SPMD) program that contains calls to a
portable run-time library.  We currently have versions of the run-time
library for SGI machines and the Stanford DASH multiprocessor.  We also
have a uniprocessor version of the library that's used for debugging and
testing.

</P>
<P>
We tested the SUIF parallelizer on several benchmark suites, and
compared its effectiveness against the KAP compiler, a commercial
parallelizing compiler from Kuck and Associates, Incorporated.
See section <A HREF="parguide_4.html#SEC4">Performance Results</A>.  Our results indicate that the SUIF
parallelizer provides a solid platform for experimentation with advanced
compiler optimizations.

</P>
<P>
The SUIF parallelizer is currently being used to support a number of
research projects.  One such project is to develop an optimizing
compiler for scalable shared address space machines.  The scalable
machine compiler includes analysis for finding data and computation
decompositions that minimize communication while preserving parallelism.
It also performs optimizations for reducing synchronization costs, and
for restructuring arrays to enhance the performance of the memory
hierarchy.

</P>
<P>
We are also working on incorporating interprocedural analysis techniques
into the SUIF parallelizer.  This includes interprocedural scalar data
flow analysis and data dependence analysis, as well as array
privatization and reduction recognition.

</P>
<P><HR><P>
<p>Go to the first, previous, <A HREF="parguide_2.html">next</A>, <A HREF="parguide_6.html">last</A> section, <A HREF="parguide_toc.html">table of contents</A>.
</BODY>
</HTML>
